﻿

var DEFAULT_HTML_STYLE = "<html>" +
  // Set the style (fonts, sizes, etc)
  "<style type=\"text/css\">" +
  "<!--" +
  "body,td,th {" +
  "	 font-family: Verdana, Arial, Geneva, Helvetica, sans-serif;" +
  "	 font-size: 12px;" +
  "	 color: #333333;" +
  "}" +
  "body {" +
  "	 margin-left: 0px;" +
  "	 margin-top: 0px;" +
  "	 margin-right: 0px;" +
  "	 margin-bottom: 0px;" +

  // Remove scrollbar from side
  "  overflow: auto;" +
  "}" +
  "-->" +
  "</style>" +

  // Disable right click
  "<script language=\"Javascript\">" +
  "  document.oncontextmenu=new Function(\"return false\")" +
  "</script>";


var httpReq = null;
var doc = null; //Xml Document
plugin.SetFlags(gddPluginFlagNone, gddContentFlagHaveDetails);
pluginHelper.onAddCustomMenuItems = onAddCustomMenuItems;


var interval = 60;
var plugin_state = 0;
var selected_url = ["http://msdn.microsoft.com/rss.xml",
"http://msdn.microsoft.com/netframework/rss.xml",
"http://msdn.microsoft.com/architecture/rss.xml",
"http://msdn.microsoft.com/asp.net/rss.xml",
"http://msdn.microsoft.com/biztalk/rss.xml",
"http://msdn.microsoft.com/directx/rss.xml",
"http://msdn.microsoft.com/downloads/rss.xml",
"http://msdn.microsoft.com/ie/rss.xml",
"http://msdn.microsoft.com/mobility/rss.xml",
"http://msdn.microsoft.com/office/rss.xml",
"http://msdn.microsoft.com/security/rss.xml",
"http://msdn.microsoft.com/sql/rss.xml",
"http://msdn.microsoft.com/vbasic/rss.xml",
"http://msdn.microsoft.com/vcsharp/rss.xml",
"http://msdn.microsoft.com/visualc/rss.xml",
"http://msdn.microsoft.com/vfoxpro/rss.xml",
"http://msdn.microsoft.com/vjsharp/rss.xml",
"http://msdn.microsoft.com/vstudio/rss.xml",
"http://msdn.microsoft.com/vs2005/rss.xml",
"http://msdn.microsoft.com/windowsmedia/rss.xml",
"http://msdn.microsoft.com/windowsvista/rss.xml"];

var item_indx= 0;
var url_Options = ["Latest News",".NET Framework","Architecture","ASP.NET","BizTalk","DirectX","Downloads","Internet Explorer 7.0","Mobile","Office","Security","SQL Server","Visual Basic","Visual #","Visual C++","Visual FoxPro","Visual J#",
"Visual Studio","Visual Studio 2005","Windows Media Player","Windows Vista"];


function onAddCustomMenuItems(menu) {
 for(var i=0;i<url_Options.length;i++)
   menu.AddItem(url_Options[i], item_indx==i ? gddMenuItemFlagChecked : 0 , changeUrl);

}

function changeUrl(item) {
  for(var i=0;i<url_Options.length;i++)
    if(item == url_Options[i]){
     item_indx = i;
    }
   view_onOpen();
}

utils.setInterval(view_onOpen, 1000 * interval);

function view_onOpen()
{
    FetchAndParse(selected_url[item_indx]);
    
}

//Fetches the Rss feed from the selected site.
function FetchAndParse(url) {
  httpReq = new XMLHttpRequest();
  httpReq.onreadystatechange = OnRssFeed;
  httpReq.open("GET", url, true);
  httpReq.send();  
}


function OnRssFeed() {
   if(httpReq.readyState==4){

      if(httpReq.status==200){
	netconn.opacity=0;  
         doc = new DOMDocument();
         doc.loadXML(httpReq.responseText);

       
         var items = doc.getElementsByTagName("item");
        
         if(items.length>1) {

	    cnArea.removeAllContentItems();
            cnArea.contentFlags = gddContentFlagHaveDetails;

            //for(var i=items.length-1;i>=0;i--){
              for(var i=0;i<items.length;i++) {
               var title, link, desc;
               for (var node = items[i].firstChild; node != null; node = node.nextSibling) {
                  if (node.nodeName == "title")
                      title = node.firstChild.nodeValue;
                   else 
                   if(node.nodeName== "link")
                      link = node.firstChild.nodeValue;
                   else
                   if(node.nodeName == "description")
                      desc = node.firstChild.nodeValue;
                }
              
        desc = desc.replace(/<([^>]|\n)*>/g,'');  // remove html tags if present
        desc = desc.replace(/&nbsp;/g, ' ');
        desc = desc.replace(/&quot;/g, '"');
        desc = desc.replace(/&amp;/g, '&');
        desc = desc.replace(/&#39;/g, '\'');
        link = link.replace(/&amp;/g, '&');
        link = link.replace(/&#39;/g, '\'');
        title = title.replace(/&amp;/g, '&');
        title = title.replace(/&#39;/g, '\'');



           if (title != null) 
           {  
                var curItem = new ContentItem();
                curItem.onDrawItem = AddBullet;
                curItem.layout = gddContentItemLayoutNews;
                curItem.flags = gddContentItemFlagNoRemove | gddContentItemFlagShareable | gddContentItemFlagHighlighted;
                curItem.onDetailsView = OnDetailsView;
		curItem.heading = title;
                curItem.snippet = desc;
		curItem.open_command = link;
                cnArea.AddContentItem(curItem, gddItemDisplayInSidebar);
                
	      }	//end if title check
                
            }                
         }
      }
else { netconn.opacity=255;  }
   }
}

function AddBullet(item, target, graphics, x, y, width, height) {
  var bgColor = "#000000";
  graphics.DrawRect(x+4, y+3, x+3, 3, bgColor, bgColor);
  graphics.DrawText(x+6, y, width, height, "  " + item.heading, gddColorNormalText, 
   gddTextFlagWordBreak, gddFontNormal);
}

function loadAndSetImage(imgUrl) {
    var httpReq2 = new XMLHttpRequest();
    httpReq2.onreadystatechange = function() {
        if(httpReq2.readyState==4 && httpReq2.status==200){
             image.src = httpReq2.responseStream; 
	            }
    };
    httpReq2.open("GET", imgUrl, true);
    httpReq2.send();
}
//Details view handler. Formats the html code and displays
function OnDetailsView(item) {
 
  var htmlcontent = DEFAULT_HTML_STYLE;
  htmlcontent += item.snippet;
  htmlcontent += "</body></html>";
  
  var control = new DetailsView();
 
  control.SetContent(item.source, item.time_created, htmlcontent, true, item.layout);
  control.html_content = true;

  var details = new Object();
  details.details_control = control;
  details.flags=gddDetailsViewFlagShareWithButton+gddDetailsViewFlagToolbarOpen;
  return details;
}




























